Package weka.classifiers.mi

# Class MISVM

java.lang.Object
weka.classifiers.Classifier
weka.classifiers.mi.MISVM

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `CapabilitiesHandler`, `MultiInstanceCapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `TechnicalInformationHandler`

public class MISVM extends Classifier implements OptionHandler, MultiInstanceCapabilitiesHandler, TechnicalInformationHandler
Implements Stuart Andrews' mi_SVM (Maximum pattern Margin Formulation of MIL). Applying weka.classifiers.functions.SMO to solve multiple instances problem.
The algorithm first assign the bag label to each instance in the bag as its initial class label. After that applying SMO to compute SVM solution for all instances in positive bags And then reassign the class label of each instance in the positive bag according to the SVM result Keep on iteration until labels do not change anymore.
For more information see:
Stuart Andrews, Ioannis Tsochantaridis, Thomas Hofmann: Support Vector Machines for Multiple-Instance Learning. In: Advances in Neural Information Processing Systems 15, 561-568, 2003.

BibTeX:

     @inproceedings{Andrews2003,
        author = {Stuart Andrews and Ioannis Tsochantaridis and Thomas Hofmann},
        booktitle = {Advances in Neural Information Processing Systems 15},
        pages = {561-568},
        publisher = {MIT Press},
        title = {Support Vector Machines for Multiple-Instance Learning},
        year = {2003}
     }

Valid options are:

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

     -C <double>
      The complexity constant C. (default 1)

     -N <default 0>
      Whether to 0=normalize/1=standardize/2=neither.
      (default: 0=normalize)

     -I <num>
      The maximum number of iterations to perform.
      (default: 500)

     -K <classname and parameters>
      The Kernel to use.
      (default: weka.classifiers.functions.supportVector.PolyKernel)

     Options specific to kernel weka.classifiers.functions.supportVector.PolyKernel:

     -D
      Enables debugging output (if available) to be printed.
      (default: off)

     -no-checks
      Turns off all checks - use with caution!
      (default: checks on)

     -C <num>
      The size of the cache (a prime number), 0 for full cache and
      -1 to turn it off.
      (default: 250007)

     -E <num>
      The Exponent to use.
      (default: 1.0)

     -L
      Use lower-order terms.
      (default: no)

Version:
  $Revision: 9144 $
Author:
  Lin Dong (ld21@cs.waikato.ac.nz)
See Also:
  - `SMO`
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`FILTER_NONE`
No normalization/standardization
`static final int`
`FILTER_NORMALIZE`
Normalize training data
`static final int`
`FILTER_STANDARDIZE`
Standardize training data
`static final Tag[]`
`TAGS_FILTER`
The filter to apply to the training data

## Constructor Summary

Constructors
Constructor
Description
`MISVM()`

## Method Summary

Modifier and Type
Method
Description
`void`
`buildClassifier(Instances train)`
Builds the classifier
`String`
`cTipText()`
Returns the tip text for this property
`double[]`
`distributionForInstance(Instance exmp)`
Computes the distribution for a given exemplar
`String`
`filterTypeTipText()`
Returns the tip text for this property
`double`
`getC()`
Get the value of C.
`Capabilities`
`getCapabilities()`
Returns default capabilities of the classifier.
`SelectedTag`
`getFilterType()`
Gets how the training data will be transformed.
`Kernel`
`getKernel()`
Gets the kernel to use.
`int`
`getMaxIterations()`
Gets the maximum number of iterations.
`Capabilities`
`getMultiInstanceCapabilities()`
Returns the capabilities of this multi-instance classifier for the relational data.
`String[]`
`getOptions()`
Gets the current settings of the classifier.
`String`
`getRevision()`
Returns the revision string.
`TechnicalInformation`
`getTechnicalInformation()`
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`String`
`globalInfo()`
Returns a string describing this filter
`String`
`kernelTipText()`
Returns the tip text for this property
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`maxIterationsTipText()`
Returns the tip text for this property
`void`
`setC(double v)`
Set the value of C.
`void`
`setFilterType(SelectedTag newType)`
Sets how the training data will be transformed.
`void`
`setKernel(Kernel value)`
Sets the kernel to use.
`void`
`setMaxIterations(int value)`
Sets the maximum number of iterations.
`void`
`setOptions(String[] options)`
Parses a given list of options.

### Methods inherited from class weka.classifiers.Classifier

`classifyInstance, debugTipText, forName, getDebug, makeCopies, makeCopy, setDebug`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### FILTER_NORMALIZE

public static final int FILTER_NORMALIZE
Normalize training data

See Also:
  - Constant Field Values

### FILTER_STANDARDIZE

public static final int FILTER_STANDARDIZE
Standardize training data

See Also:
  - Constant Field Values

### FILTER_NONE

public static final int FILTER_NONE
No normalization/standardization

See Also:
  - Constant Field Values

### TAGS_FILTER

public static final Tag[] TAGS_FILTER
The filter to apply to the training data

## Constructor Details

### MISVM

public MISVM()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

public TechnicalInformation getTechnicalInformation()
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

Specified by:
  `getTechnicalInformation` in interface `TechnicalInformationHandler`
Returns:
  the technical information about this class

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options

Specified by:
  `listOptions` in interface `OptionHandler`
Overrides:
  `listOptions` in class `Classifier`
Returns:
  an enumeration of all the available options

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

     -C <double>
      The complexity constant C. (default 1)

     -N <default 0>
      Whether to 0=normalize/1=standardize/2=neither.
      (default: 0=normalize)

     -I <num>
      The maximum number of iterations to perform.
      (default: 500)

     -K <classname and parameters>
      The Kernel to use.
      (default: weka.classifiers.functions.supportVector.PolyKernel)

     Options specific to kernel weka.classifiers.functions.supportVector.PolyKernel:

     -D
      Enables debugging output (if available) to be printed.
      (default: off)

     -no-checks
      Turns off all checks - use with caution!
      (default: checks on)

     -C <num>
      The size of the cache (a prime number), 0 for full cache and
      -1 to turn it off.
      (default: 250007)

     -E <num>
      The Exponent to use.
      (default: 1.0)

     -L
      Use lower-order terms.
      (default: no)

Specified by:
  `setOptions` in interface `OptionHandler`
Overrides:
  `setOptions` in class `Classifier`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the classifier.

Specified by:
  `getOptions` in interface `OptionHandler`
Overrides:
  `getOptions` in class `Classifier`
Returns:
  an array of strings suitable for passing to setOptions

### kernelTipText

public String kernelTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getKernel

public Kernel getKernel()
Gets the kernel to use.

Returns:
  the kernel

### setKernel

public void setKernel(Kernel value)
Sets the kernel to use.

Parameters:
  `value` - the kernel

### filterTypeTipText

public String filterTypeTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setFilterType

public void setFilterType(SelectedTag newType)
Sets how the training data will be transformed. Should be one of FILTER_NORMALIZE, FILTER_STANDARDIZE, FILTER_NONE.

Parameters:
  `newType` - the new filtering mode

### getFilterType

public SelectedTag getFilterType()
Gets how the training data will be transformed. Will be one of FILTER_NORMALIZE, FILTER_STANDARDIZE, FILTER_NONE.

Returns:
  the filtering mode

### cTipText

public String cTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getC

public double getC()
Get the value of C.

Returns:
  Value of C.

### setC

public void setC(double v)
Set the value of C.

Parameters:
  `v` - Value to assign to C.

### maxIterationsTipText

public String maxIterationsTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getMaxIterations

public int getMaxIterations()
Gets the maximum number of iterations.

Returns:
  the maximum number of iterations.

### setMaxIterations

public void setMaxIterations(int value)
Sets the maximum number of iterations.

Parameters:
  `value` - the maximum number of iterations.

### getCapabilities

public Capabilities getCapabilities()
Returns default capabilities of the classifier.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Classifier`
Returns:
  the capabilities of this classifier
See Also:
  - `Capabilities`

### getMultiInstanceCapabilities

public Capabilities getMultiInstanceCapabilities()
Returns the capabilities of this multi-instance classifier for the relational data.

Specified by:
  `getMultiInstanceCapabilities` in interface `MultiInstanceCapabilitiesHandler`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### buildClassifier

public void buildClassifier(Instances train) throws Exception
Builds the classifier

Specified by:
  `buildClassifier` in class `Classifier`
Parameters:
  `train` - the training data to be used for generating the boosted classifier.
Throws:
  `Exception` - if the classifier could not be built successfully

### distributionForInstance

public double[] distributionForInstance(Instance exmp) throws Exception
Computes the distribution for a given exemplar

Overrides:
  `distributionForInstance` in class `Classifier`
Parameters:
  `exmp` - the exemplar for which distribution is computed
Returns:
  the distribution
Throws:
  `Exception` - if the distribution can't be computed successfully

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Classifier`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - should contain the command line arguments to the scheme (see Evaluation)